%  Copyright 2013 Ternarylogic LLC. All Rights Reserved
% title: scramlfsrbingal.m
% a 4-state LFSR scrambler of sequence sin4 in Galois configuration 
shifts=[3 1 0 2]+1; % the initial state of the shift register in origin 1
shifts-1          % display initial shift register content
sc1=[0 1 2 3;1 0 3 2;2 3 0 1;3 2 1 0]+1;  % the binary XOR function
sc3=sc1;
sc4=sc1;
ds4=sc1;
sin4=[1 2 3 1 0 0 0 0 1 2 3 1 0 3 0 1 2 0 1 2 1 3 1 1]+1;
sin4-1
lent=size(sin4);
len=lent(2);
for i=1:len             % shift the bits of the LFSR 
    in=shifts(4);       % the output of SR3
    in3=shifts(3);      % the output of SR2
    in1=shifts(1);        % the output of SR1
    in11=sin4(i);       % the input symbol on sc1
    t3=sc3(in,in3);     % apply 'sc3'
    t1=sc1(in11,in1);   % apply 'sc1'
    
    out4(i)=sc4(in,sin4(i));  % scrambled symbol in generated sequence
                              % on output
    % shift symbols in the shift register
    shifts(4)=t3;        
    shifts(3)=shifts(2);
    shifts(2)=t1;      
    shifts(1)=out4(i);
    
end  
out4-1         % the sequence of scrambled symbols on the output

